(function scriptedWebServiceOperation(request, response) {

    if (typeof GlideStringUtil != 'undefined')
       var StringUtil = GlideStringUtil;
    else
       var StringUtil = Packages.com.glide.util.StringUtil;

    var xmldoc = new XMLDocument("<Response></Response>");
    var results = xmldoc.createElement("Results");
    try {
            var gr = new GlideRecord("sys_attachment");
            var start_index=Number(request.start_index);
            var max_count=Number(request.max_count);
            gr.addEncodedQuery(request.query);
            if(start_index>0 || max_count>0) {
                    gr.chooseWindow(start_index,start_index+max_count);
            }
            gr.query();
            while (gr.next()){
               var currentPayload=gr.size_bytes;
               xmldoc.setCurrent(results);
               var attachment = xmldoc.createElement("attachment");
               xmldoc.setCurrent(attachment); 
               if (typeof GlideSysAttachment != 'undefined')
                      var sa = new GlideSysAttachment();
               else
                      var sa = new Packages.com.glide.ui.SysAttachment();
               var binData = sa.getBytes(gr);
               if(binData.length==0 && currentPayload>0) {
                            xmldoc.createElement("error","Failed to retrieve attachment payload. Too large? [" + currentPayload +" bytes]");
                       xmldoc.createElement("sys_attachment",gr.sys_id);
                       xmldoc.createElement("size",currentPayload);
               }
                    else {
                       var encData = StringUtil.base64Encode(binData);
                       xmldoc.createElement("sys_attachment",gr.sys_id);
                       xmldoc.createElement("data",encData);
                       xmldoc.createElement("size",currentPayload);
                    }
            }
    }
    catch(e) {
             xmldoc.createElement("error",e.message);
    }
    response.soapResponseElement = xmldoc.getDocumentElement();
})(request, response);


