/* 
 * Copyright (c) Service Management Integrations Limited, 2014 - 2018
 * All Rights Reserved.
 * NOTICE: All information contained herein is and remains the property of Service Management  Integrations Limited.  The intellectual and technical concepts contained herein are proprietary to Service Management Integrations Limited and are protected by copyright law.  Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained from Service Management Integrations Limited.
 */

(function transformRow(source, target, map, log, isUpdate) {
        //##!MANAGED CODE!##
	ignore = true;
	try {
		var gr=new GlideRecord('sys_variable_value');
		var newEntry=false;
		gr.addEncodedQuery("document_key="+ source.parent_id+"^variable="+source.variable);
                gr.query();
		if(!gr.next()) {
			gr.initialize();
			newEntry=true;
		}
		gr.document=source.parent_table;
		gr.document_key=source.parent_id;
		gr.order=source.order;
		gr.value=source.value;
		gr.variable=source.variable;
		if(newEntry) {
			gr.insert();
			status_message="inserted;" + gr.sys_id;
		}
		else {
			gr.update();
			status_message="updated;" + gr.sys_id;
		}
		log.info(status_message);
	}
	catch(e) {
		error=true;
		error_message="error: journal entry addition [ " + source.variable+"]\n"+e.message();
		log.info(error_message);
	}

})(source, target, map, log, action==="update");


